#!/bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=30_fsm_notifyRestoreHACheck
. /usr/bin/gettext.sh

RUN_AS_ROOT=/opt/ibm/director/vmi/bin/execWithPrivilege

#0: This is the active HA node. 
#1: Error
#2: HA configuration is being removed
#3: This is the passive HA node
#4: HA is not configured
#5: HA configuration is starting (RC is internal to the routine only and is never returned)
#6: HA configuration is in progress (lots of different ones with this)
#7: HA is "stopped"
#8: Pending  (a resource is moving from online to offline or from offline to online)

$RUN_AS_ROOT smhapstatus.sh > /dev/null 2>&1
case $? in
    0|3) 
    	 printf "`gettext 'You should only restore a node in a high availability environment if both nodes have been replaced or if you need to revert to a backup image. Before restoring this node, you must reinstall the FSM image on the peer node. After restoring this node, run Replace Passive Node from this node to bring the peer node back into the cluster. All data is replicated from the reinstalled node to the peer node.'`\n"
    	 exit 0
    	 ;;
    2|4) 
    	 exit 0
    	 ;;
esac
exit 1