#!/bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=30_fsm_validateBackupNoJobs
. /usr/bin/gettext.sh

#do the check here for running jobs, after ensuring that Director isn't running
smstatus >> /dev/null 2>&1
rc=$?

if [[ $rc -ne 3 ]]; then
	starttime=`date +%s`
	currenttime=$starttime

	runningjobs=`smcli lsjob -m | grep -i active | wc -l`

	while [[ $currenttime -lt $starttime+300 && $runningjobs -ne 0 ]]
	do
		sleep 2
		currenttime=`date +%s`
		runningjobs=`smcli lsjob -m | grep -i active | wc -l`
	done

	if [[ $runningjobs -ne 0 ]]; then
		if [[ -e $ONE_TIME_PROPERTIES ]]; then
			LOG_FILE=`sed '/^\#/d' $ONE_TIME_PROPERTIES | grep 'log'  | tail -n 1 | cut -d "=" -f2- | sed 's/^[[:space:]]*//;s/[[:space:]]*$//'`

			printf "`date +%m/%d/%Y%t%H:%M:%S` - `gettext ' Backup terminated because there are background jobs running.'`\n" >> $LOG_FILE 2>&1
		else
			printf "`gettext 'Backup did not complete because there are background jobs running. Either terminate the background jobs or wait for the jobs to terminate (use smcli lsjob -m to determine if there are active jobs).'`\n"
    	fi
		exit -10
	fi
fi

exit 0