#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

#!/bin/bash

#Edit outfile with new service.
host=$(hostname)
date=$(date)
outfile="/etc/opt/ibm/icc/slp.reg"
IPinput="/etc/opt/ibm/icc/lsnetcfg.out"
/opt/ibm/director/vmi/bin/lsnetcfg -n > $IPinput 2>&1
version=$(cat /opt/ibm/director/lwi/runtime/itme/eclipse/plugins/isdvmi.version | grep 'version' | cut -d "=" -f2)
ipv4_eth0=$(cat $IPinput | grep ipv4addr_eth0 | cut -d ":" -f2 | cut -d " " -f2)
ipv6ula_eth0=$(cat $IPinput | grep ipv6addr_eth0 | cut -d ":" -f2- | cut -d "/" -f1 |  cut -d " " -f2)
ipv6list=$(cat $IPinput | grep ipv6addr_eth0 | cut -d ":" -f2-)
startIndex=$(awk -v a="$ipv6list" -v b="fe80:" 'BEGIN{print index(a,b)}') 
ipv6lla_eth0=$(awk -v a="$ipv6list" -v i="$startIndex" 'BEGIN{print substr(a, i, 30)}' | cut -d "/" -f1)
echo "#"$host": Creating file "$date"" > $outfile
	
#params: ip, Chassis attr, PassiveIP attr
function regServ () {

	echo "service:management-itmesoftware.IBM:systems-director-server://"$1",en,65535" >> $outfile
	echo "LinklocalIP="$ipv6lla_eth0"" >> $outfile
	echo "Version="$version"" >> $outfile
	echo "PassiveIP="$3"" >> $outfile
	#Parse slp attribute
	attr=$(echo $2 | tr "@" "\n")
	for x in $attr
	do
	echo "Chassis="$x"" >> $outfile
	done
	echo "" >> $outfile

}

if [ -n "$ipv4_eth0" -a "$ipv4_eth0" != "0.0.0.0" -a "$ipv4_eth0" != "127.0.0.1" ]
then
    regServ "$ipv4_eth0" "$1" "$2"
else 
    echo "#ipv4_eth0 is a invalid IP." >> $outfile
fi

len=$(expr length "$ipv6ula_eth0")
if [ $len -gt 2 ]
then
    regServ "$ipv6ula_eth0" "$1" "$2"
else 
    echo "#ipv6ula_eth0 is a invalid IP." >> $outfile
fi

#Start SLPD to trigger static registration file.
/etc/init.d/paslpd restart

exit 0 