#! /bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

#
# Valid options: -d, -f, -u, -l
# Options:
# -d backup : backup was a hdd backup with the backup name
# -f : backup was a ftp backup
# -u backup : backup was an usb backup with the backup name
# -l log file : the log file associated with the backup <TODO May or may not include path>

export PATH=/usr/bin:/sbin:/usr/sbin:/bin:$PATH

#Constants
USB_PATH="/dev/usb/"
DISK_PATH="/media/"
LOG_FILE_PATH="/root/"

TYPE=""
USERID=""
PASSWORD=""
BACKUPNAME=""
LOGFILE=""

print_usage() {
        exit 0
}

numArgs=$#

ARGS=`getopt -ua -n $COMMAND_NAME -o "h:d:u:f:l" -- $*`
[[ $? -ne 0 ]] && exit 1
set $ARGS --

# Parse the arguments
while [ "$1" != "--" ]
do
	case "$1" in
		-h|--help) print_usage;;
		-d)
			TYPE="hdd"
			if [ $numArgs -eq 4 ]; then
				shift
				BACKUPNAME=$1
			fi
			;;
		-u)
			TYPE="usb"
			shift
			;;
		-f)
			TYPE="ftp"
			shift
			;;
		-l)
			shift
			LOGFILE=$1
			;;
		*) print_usage;;
	esac
	shift
done

rm $LOGFILE

path="$(readlink -m /dev/disk/by-path/$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand ls /dev/disk/by-path/ -lah | grep -iP 'sas.*part3' | sed -r 's/.*->(.*)/\1/g' | sed 's/^[[:space:]]*//;s/[[:space:]]*$//'))"

ismounted=`/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mount | grep $path | wc -l`
	ismediaused=`/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mount | grep /media | wc -l`
	mountedtogether=`/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mount | grep $path | grep /media | wc -l`
	if [[ $ismounted -eq 0 && $ismediaused -eq 0 ]]; then
		/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mount $path /media
	elif [[ $mountedtogether -eq 0 ]]; then
	 	/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand umount /media
	  	/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mount $path /media
	fi

if [ $TYPE == "hdd" -a $numArgs -eq 4 ]; then
	/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand rm $DISK_PATH$BACKUPNAME*
fi

LOGFILE=$(echo $LOGFILE | cut -d'/' -f 3)
/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand rm $DISK_PATH$LOGFILE
