#! /bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

export PATH=/usr/bin:/sbin:/usr/sbin:/bin:$PATH

ONE_TIME_PROPERTIES="/tmp/.tempBackup.properties"

if [[ -e $ONE_TIME_PROPERTIES ]]; then
	backupType=`sed '/^\#/d' $ONE_TIME_PROPERTIES | grep 'type'  | tail -n 1 | cut -d "=" -f2- | sed 's/^[[:space:]]*//;s/[[:space:]]*$//'`
fi

if [[ -e $ONE_TIME_PROPERTIES && $backupType != "usb" ]]; then
	exit 9
fi

#Get the mount point for the USB device
mountPoint=`/usr/smrshbin/lsmediadev | grep -i type=3 | tr ',' '\n' | grep mount_point | cut -d'=' -f 2-`

[[ $? -ne 0 ]] && exit 6

mountCount=`/usr/smrshbin/lsmediadev | grep -P type=3 | wc -l`

if [[ $mountCount -eq 0 ]]; then
        exit 7
fi

if [[ $mountCount -gt 1 ]]; then
	exit 10
fi

if [ $# -eq 0 ]; then
	number=`mount $mountPoint 2>&1 | grep "can't find $mountPoint" | wc -l`
else
	if [ $1 = -u ]; then
		number=`umount $mountPoint 2>&1 | grep "can't find $mountPoint" | wc -l`
	fi
fi

[[ $? -ne 0 ]] && exit $?

[[ $number -ne 0 ]] && exit 9

exit 0