#!/bin/bash

#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

#TODO Temporary
#To print out mock backup list change set "useMock=true" to actually run the
#production code set "useMock=false"
useMock=f


if [ $useMock == true ]; then
        echo "/local/backup04112011$/tmp/03#11#2011#09#10_#tmp#backup_hdd_safe_20.log"
        echo "/usb/backups/backup04122011$/tmp/03#12#2011#09#09_#tmp#backup_usb_safe_20.log"
        echo "/local/backup04132011$/tmp/03#13#2011#09#10_#tmp#backup_hdd_safe_20.log"
        exit 0
fi

#TODO End Temporary

#Constants #TODO These will need to change to the correct paths
USB_PATH="/dev/usb/"
DISK_PATH="/media/"
LOG_FILE_PATH="/root/"
backuplevel=""
backupsuccess=""

read_backup_level(){
	if [[ $(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand grep -cP 'level=' $1 2> /dev/null) -gt 0 ]];then
		backuplevel='$'$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand grep -P 'level=' $1 2> /dev/null | sed 's/level=//')
	else
		backuplevel=""
	fi

	if [[ $(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand grep -cP 'returncode=' $1 2> /dev/null) -gt 0 ]];then
		backupsucces='$'$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand grep -P 'returncode=' $1 2> /dev/null | sed 's/returncode=//')
	else
		backupsucces=""
	fi
}

logs=`ls $LOG_FILE_PATH | grep -P _[0-9]{2}.log`

path="$(readlink -m /dev/disk/by-path/$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand ls /dev/disk/by-path/ -lah | grep -iP 'sas.*part3' 2> /dev/null | sed -r 's/.*->(.*)/\1/g' | sed 's/^[[:space:]]*//;s/[[:space:]]*$//'))"

ismounted=$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mount | grep $path 2> /dev/null | wc -l)
ismediaused=$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mount | grep /media 2> /dev/null | wc -l)
mountedtogether=$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mount | grep $path 2> /dev/null | grep /media | wc -l)
if [[ $ismounted -eq 0 && $ismediaused -eq 0 ]]; then
	/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mount $path /media
elif [[ $mountedtogether -eq 0 ]]; then
 	/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand umount /media
  	/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mount $path /media
fi
backupFiles=$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand ls /media | grep tar.gz 2> /dev/null | grep -v md5 2> /dev/null)

hddLogs=$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand ls /media | grep -P _[0-9]{2}.log 2> /dev/null)

unorphanedBackups=""

for log in $logs
do
	count=`echo $log | grep hdd | wc -l`
	if [ $count -eq 1 ]; then
    		backupDate=$(grep -oP -m 1 [0-9]{14}.tar.gz $LOG_FILE_PATH$log 2> /dev/null)
		if [[ $(echo $backupDate | grep -oP -m 1 [0-9]{14}.tar.gz | wc -l) -eq 0 && $(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand ls /media | grep $log | wc -l) -ne 0 ]]; then
        		backupDate=$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand grep -oP -m 1 [0-9]{14}.tar.gz /media/$log 2> /dev/null)
        	fi
        	for backup in $backupFiles
        	do
			if [[ $(echo $backupDate | grep -oP -m 1 [0-9]{14}.tar.gz | wc -l) -ne 0 ]];then
				backupExist=`echo $backup | grep $backupDate | wc -l`
                		if [ $backupExist -ge 1 ]; then
            				unorphanedBackups=$unorphanedBackups" "$backup
                			break
                		else
                			backup=""
                		fi
            		else
            			#We get down here when the backup didn't match the current logfile
            			backup=""
            		fi
        	done
		read_backup_level /media/$log
		echo $backup'$'$LOG_FILE_PATH$log$backuplevel$backupsucces
	else
		backup=$(grep -oP -m 1 [0-9]{14}.tar.gz $LOG_FILE_PATH$log 2> /dev/null)
        	if [[ $(echo $backup | wc -l) -eq 0 && $(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand ls /media | grep $log | wc -l) -ne 0 ]]; then
			backup=$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand grep -oP -m 1 [0-9]{14}.tar.gz /media/$log 2> /dev/null)
	    	fi
		read_backup_level /media/$log
    		echo $backup'$'$LOG_FILE_PATH$log$backuplevel$backupsucces
	fi
	tempHddLogs=""
	for hddLog in $hddLogs
	do
		tempHddLogs=$tempHddLogs" "$( echo $hddLog | grep -v $log)
	done
	hddLogs=$tempHddLogs
done

for log in $hddLogs
do
	count=`echo $log | grep hdd | wc -l`
	if [ $count -eq 1 ]; then
        	backupDate=$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand grep -oP -m 1 [0-9]{14}.tar.gz /media/$log 2> /dev/null)
        	for backup in $backupFiles
        	do
			if [[ $(echo $backupDate | grep -oP -m 1 [0-9]{14}.tar.gz | wc -l) -ne 0 ]];then
				backupExist=`echo $backup | grep $backupDate | wc -l`
                		if [ $backupExist -ge 1 ]; then
            				unorphanedBackups=$unorphanedBackups" "$backup
                			break
                		else
                		backup=""
                		fi
            		else
            			backup=""
            		fi
        	done
		read_backup_level /media/$log
		echo $backup'$'$LOG_FILE_PATH$log$backuplevel$backupsuccess
	else
		backup=$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand grep -oP -m 1 [0-9]{14}.tar.gz /media/$log 2> /dev/null)
		read_backup_level /media/$log
    		echo $backup'$'$LOG_FILE_PATH$log$backuplevel$backupsucces
	fi
done

orphenedBackups=$backupFiles
for unorphenedBackup in $unorphanedBackups
do
	orphenedBackupsTemp=""
	for backup in $orphenedBackups
	do
		orphenedBackupsTemp=$orphenedBackupsTemp" "$(echo $backup | grep -v $unorphenedBackup)
	done
	orphenedBackups=$orphenedBackupsTemp
done

for orphenedBackup in $orphenedBackups
do
	# Parse modify date from stat command into "Modify: 2012-06-04 17:43:48.149516889 +0000"
	modifyDate=$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand stat /media/$orphenedBackup | grep Modify)
	
	# Parse into [yyyy-mm-dd, hh:mm]
	inputDate=$(awk -v a="$modifyDate" 'BEGIN{print substr(a, 9, 16)}')
	tsArr=($(echo $inputDate | tr " " "\n"))
	
	# Parse into [yyyy,mm,dd]
	dateArr=($(echo ${tsArr[0]} | tr "-" "\n"))
	year=${dateArr[0]}
	month=${dateArr[1]}
	day=${dateArr[2]}
	
	# Parse into [hh, mm]
	timeArr=($(echo ${tsArr[1]} | tr ":" "\n"))
	hr=${timeArr[0]}
	min=${timeArr[1]}
		
	fakeLog=$month'#'$day'#'$year'#'$hr'#'$min'_10.3.0.1#media#_hdd_unsafe_fake.log'		
	echo $orphenedBackup'$'$LOG_FILE_PATH$fakeLog
done
