#!/bin/sh
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#
export PATH=/usr/bin:/sbin:/usr/sbin:/bin:$PATH

printUsage()
{
echo "Usage: quicklogs [--help | --full]"
echo "Create a zip file of the logs and store it in this directory."
echo "Without any options, just collect all files in the main log directory."
echo ""
echo "  --help   print this usage information"
echo "  --full   add more files to those included by default"
echo ""
echo "Examples:"
echo "quicklogs"
echo "quicklogs --full"
echo "quicklogs --help"
}

/opt/ibm/director/vmi/bin/execWithPrivilege auditLogger quicklogs

# if there are no args
if [ $# -eq 0 ]; then
    echo "Creating zip file of main logs"
    zip -j error-logs /opt/ibm/director/lwi/logs/*
    exit $?
fi

# if there is more than one arg
if [ $# -gt 1 ]; then
    printUsage
    exit 1
fi

# There was 1 arg passed in
if [ "$1" == "--full" ]; then
    echo "Creating zip file of main logs plus additional logs"
    /opt/ibm/director/bin/logcollector -o ./
else
    printUsage
    exit 1
fi

exit $?
