#!/bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=restoreHDD
export PATH=/usr/bin:/bin:$PATH
. /usr/bin/gettext.sh

print_usage (){
	printf "`gettext 'Usage: restoreHDD {backup file name}\n\nExample:\n  restoreHDD 20110110131235.tar.gz'`\n"
	/opt/ibm/director/vmi/bin/execWithPrivilege auditLogger restoreHDD 1
}

RESTORE_COMMAND="launchRestore.sh"

# Check number of args
if [ $# -ne 1 ]; then
	print_usage
	exit 1
fi

# print help
if [ "$1" == "-h" ] || [  "$1" == "--help" ]; then
	print_usage
	exit 0
fi 

filename=$1

/opt/ibm/director/vmi/bin/execWithPrivilege $RESTORE_COMMAND -d $filename
/opt/ibm/director/vmi/bin/execWithPrivilege auditLogger restoreHDD $?
