#!/bin/bash

#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

#### Standard code to find an pull in all sm common code ####
INSTALL_DIR=/opt/ibm/director
CMD_DIR=$INSTALL_DIR/ha/bin/tsa
COMMON_CODE=/opt/ibm/director/ha/bin/include/smhacommon.sh

if [ -f $COMMON_CODE ]; then
    source $COMMON_CODE
else
    echo "$PROGNAME:Common code not found."
    exit 1
fi
#############################################################

STANDBY_BIN_DIR=/opt/ibm/director/standby/bin

if ps -ef | grep -v grep | grep profile.standby > /dev/null
then

	# Check to see if web console is accessible
	curl -k https://localhost:8422/ibm/console 1>/dev/null 2>/dev/null
	rc=$?
	if [ $rc -eq 0 ]
	then
	    exit 0;
	fi
	
	# Web console is not up yet
	exit 1;
fi

exit 1;
