#!/bin/bash

#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2010 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

#### Standard code to find an pull in all sm common code ####
INSTALL_DIR=/opt/ibm/director
CMD_DIR=$INSTALL_DIR/ha/bin/tsa
EXPLOITER_CODE=/opt/ibm/director/ha/bin/include/smha_exploiter_common.sh

if [ -f $EXPLOITER_CODE ]; then
    source $EXPLOITER_CODE
else
    echo "$PROGNAME:Exploiter code not found."
    exit 1
fi
#############################################################



STANDBY_BIN_DIR=/opt/ibm/director/standby/bin



RC=$TSA_UNKNOWN  

Action=${1}

case ${Action} in
start)
    smha_record_tsa_action ${Action} frmstandby "-"
    ${STANDBY_BIN_DIR}/launchstandby.sh
    retVal=$?
    case $retVal in
    	0) #SUCCESSFUL
    		;;
    	*) #FAILED
    		;;
    esac
    RC=0
    ;;
stop)
    smha_record_tsa_action ${Action} frmstandby "-"
    ${STANDBY_BIN_DIR}/stopstandby.sh
    retVal=$?
    case $retVal in
    	0) #SUCCESSFUL
    		;;
    	*) #FAILED
    		;;
    esac
    RC=0
    ;;

status)
    ${STANDBY_BIN_DIR}/standbystatus.sh
    statusrc=$?
    case $statusrc in
        0) #ACTIVE
            RC=${TSA_ONLINE}
            ;;
        *) #INACTIVE
            RC=${TSA_OFFLINE}
            ;;
    esac
    ;;
esac


smha_record_tsa_action ${Action} frmstandby $RC
exit $RC
